﻿using System.Linq;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;

namespace DBLocalizationExample
{
    public class MvcApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);

            // register a model metadata provider that converts text-ids in the Display attribute into texts
            ModelMetadataProviders.Current = new MetadataProvider();

            // register a model validation provider to use our own model validator
            var provider = ModelValidatorProviders.Providers.FirstOrDefault(p => p.GetType() == typeof(DataAnnotationsModelValidatorProvider));
            if (provider != null)
            {
                ModelValidatorProviders.Providers.Remove(provider);
            }
            ModelValidatorProviders.Providers.Add(new LocalizableModelValidatorProvider());
        }
    }
}
